/*		CLTRM.C  - to enter Coulter Counter data via keyboard */
#define MAIN
#include <stdio.h>
#include "sedlab.h"

#include "gstat.h"

main(argc,argv)
char *argv[];
int argc;
{
	/*  udlist is an array of character strings representing the allowed
		micron-diameters (ud) for grain size analyses  
	    fplist is an array of character strings which correspond to
		the analyses of each aperature diameter */

	/* iopt = 1 is for 200 ud analysis only
		  2         30 ud analysis only
		  0        200 & 30 ud analysis  */
	
	/* udinit is initially set to 50.8 for 200 ud analysis and  to
				      12.7 for 30  ud analysis 
			but these may be changed in getsam */

	int iopt,udinit;
	int getids(),getopt();

	FILE *master;

	char fplist[MAXDLIST][MAXFPLET];


	static char *udlist[] = {"1024.0","812.0","645.0","512.0","406.0",
				 "322.0","256.0","303.0","161.0","128.0",
				 "101.6","80.6","64.0","50.8","40.3",
				 "32.0","25.4","20.2","16.0","12.7",
				 "10.08","8.0","6.35","5.04","4.00",
				 "3.17","2.52","2.00","1.59","1.26",
				 "1.00","0.794","0.630","0.500","0.397",
				 "0.315","0.250","0.198"};
	
	if (argc < 2) {
		fprintf (stderr,"CLTRM: Usage 'cltrm master_file_name'\n");
		exit(1);
		}
	
	while (--argc) { /* for all master files listed on run-line */

	if ( (master = fopen(*++argv,"a")) == NULL) {
		fprintf(stderr,"CLTRM: Error opening master_file: '%s'\n",
				*argv);
		exit(1);
		}

	if (getids() == NULL)  {
		fclose(master);
		continue;
		}

	if ( (iopt = getopt()) == EOF )
		{
		fclose(master);
		continue;
		}
	
	while (csetup() != EOF)
		{
		udinit = UD200;
		if (iopt == 0 || iopt == 1) {
			printf ("\n\n FOR  200 UD:  \n");
			if (getsam(udlist,&udinit,fplist) == NULL)  
				continue;
			mprint(master,"200",udlist,udinit,fplist);
			}
		udinit = UD30;
		if (iopt == 0 || iopt == 2) {
			printf ("\n\n FOR 30 UD:  \n");
			if (getsam(udlist,&udinit,fplist) == NULL) continue;
			mprint (master,"30",udlist,udinit,fplist);
			}
		}
	fclose(master);
	}

}


