/* gsanv - to enter labno,lat,lon & other sample ids for sediment analysis
	   data sets used in gstat 	*/
#include <stdio.h>
#include "sedlab.h" 
main(argc,argv)
int argc;
char *argv[];
	{
	FILE *master;
	char labno[MAXLABLET]=" ",latd[MAXCOORDLET]=" ",lond[MAXCOORDLET]=" ",
		device[MAXDEVLET]=" ",area[MAXAREA]=" ",depth[MAXDEPTHLET]=" ",
		dtop[MAXDEPTHLET]=" ",dbot[MAXDEPTHLET]=" ",eorw[MAXANS]=" ",
		nors[MAXANS]=" ",date[MAXANADAT]=" ";
	float aval,latdm,londm;
	int latdd,londd,ddflag,dflag;

	/* input is from stdin - output goes to stdout */
	if (argc <= 1)
		{
		fprintf(stderr,"gsanv [-cd] master_file_name.\n");
		exit(1);
		}

	ddflag = 0;
	dflag = 0;
	if (**++argv == '-')
		{
		argv++;
		argc--;
		ddflag = 1;
		dflag = 1;
		}
	if (--argc <= 0)
		{
		fprintf(stderr,"gsanv [-c] master_file_name\n");
		exit(1);
		}
	if ( (master = fopen(*argv,"a")) == NULL)
		{
		fprintf(stderr,"Error opening file.\n");
		exit(1);
		}

	labno[0] = '\0';
	while (labno[0] != '.')
		{
/*		if (prompt("Enter labno:   ",labno,MAXLABLET) == EOF ) break;*/
		if (fetch(" Enter labno ",labno,MAXLABLET) == EOF)  continue;
		if (labno[0] == '.')  break;
		if (!ddflag)
			{
			if (prompt("Enter latitude :  ",latd,MAXCOORDLET) ==
				EOF)  continue;
			if (prompt("Enter longitude:  ",lond,MAXCOORDLET) ==
				EOF)  continue;
			}
		else
			{
			printf ("Enter latidude (deg min N or S): ");
			if(scanf ("%d %f %s",&latdd,&latdm,nors) == EOF)
				continue;
			printf ("Enter longitude (deg min E or W): ");
			if(scanf ("%d %f %s",&londd,&londm,eorw) == EOF)
				continue;
			if (getchar() == EOF)  continue;
			aval = latdd + latdm/60.0;
			sprintf(latd,"%.5f",(nors[0] == 'S'? -aval:aval));
			aval = londd + londm/60.0;
			sprintf(lond,"%.5f",(eorw[0] == 'W'? -aval:aval));
			}
		if (fetch("Enter 2 char device code ",device,MAXDEVLET) ==
			EOF)  continue;
		if (fetch("Enter 2 char area code ",area,MAXAREA) ==
			EOF) continue;
		if (fetch("Enter sample depth ",depth,MAXDEPTHLET) ==
			EOF) continue;
		if (fetch("Enter top depth ",dtop,MAXDEPTHLET) == EOF)
			continue;
		if (fetch("Enter bottom depth ",dbot,MAXDEPTHLET) == EOF)
			continue;
		/*
		if (fetch("Enter mo/da/yr ",date,MAXANADAT) == EOF)
			continue;
		*/
		fprintf(master,">>%s NAV %s,%s,%s,%s,%s,%s,%s\n",labno,latd,
			lond,device,area,depth,dtop,dbot);
		printf ("\n\n");
		}
	}

