/*  getcltr - to retrieve coulter data from master file */
#include "sedlab.h"
#include "gstat.h"

getcltr(type,array,dend)
int type;  
double array[];
int *dend;
	{
	char *strtok(),*word;
	double diameter,atof();

	static double udlist[] = {1024.0,812.0,645.0,512.0,406.0,
				 322.0,256.0,303.0,161.0,128.0,
				 101.6,80.6,64.0,50.8,40.3,
				 32.0,25.4,20.2,16.0,12.7,
				 10.08,8.0,6.35,5.04,4.00,
				 3.17,2.52,2.00,1.59,1.26,
				 1.00,0.794,0.630,0.500,0.397,
				 0.315,0.250,0.198};
	
	if (loadids() == EOF)  return(EOF);
	if (type == 200)
		strncpy(alab,labno,MAXLABLET);
	else
		if (strcmp(alab,labno) != 0)
			{
			printf ("Master file out of order.  Abort!\n");
			exit(1);
			}
	*dend = MAXDLIST-1;
	while (getlin() != EOF)
		{
		if (line[0] == '>') 
			break;
		if ((word = strtok(line," ")) == cnull)
			error("NULL LINE IN FILE. ABORTED!!\n");
		diameter = atof(word);
		while (*dend)
			{
			if (diameter == udlist[*dend])  break;
			*dend = *dend - 1;
			}
		if (*dend <= 0)
			{
			printf ("%10.3f is not in micron-diameter list\n",
				diameter);
			printf ("Program aborted.\n");
			exit(1);
			}
		if ( (word = strtok(cnull," ")) == cnull)
			error("Missing frq percent on line.\n");
		array[*dend] = atof(word);
		*dend = *dend - 1;
		}
	for (*dend = MAXDLIST -1; *dend >= 0 ; *dend = *dend - 1)
		if (array[*dend] != 0.0)  break;
	*dend = *dend + 1;
	return (~EOF);
	}

