/* getdat - to get 200 and 30 micron diameter coulter data , RSA coarse data,
	    and NAV identifiers for input into program GSTAT 
		written Feb 1985 - jjfredericks		*/
#include "sedlab.h"
#include "gstat.h"
int	
getdat (fplist)
double fplist[];
	{
	double c200[MAXDLIST],c30[MAXDLIST];
	int dend;

	/* patch to clear automatic arrays c200 and c30 to zeros GIE */
	for (dend=0; dend < MAXDLIST; ++dend)
		c200[dend] = c30[dend] = 0.;
	if (getcltr(200,c200,&dend) == EOF)  return (EOF);
	if (getcltr(30,c30,&dend) == EOF)  return (EOF);
        if (getnav() == EOF)  return (EOF);
        if (getrsa(fplist) == EOF)  return (EOF); 
	fprintf (stderr,"Data retrieved for %s\n",labno);
	if ( (pfine = (sample - coarse)/sample) > 0.0001)
		{
  		mpvc(c200,c30,dend);   
		sumry(c200,fplist);
		}
  	wtfp(fplist); 
/* fplist now contains [0 to dend] fine,sand and gravel normalized to 100% */
	for (dend = MAXPLIST - 1; dend >= 0 ; dend--)
		if (fplist[dend] > 0.001)  break;
	/* fplist[dend] is now the first non-Zero value checking from coarse to fine;
*/
	return (dend);
	}

