/*  gstatm - to retrieve cfp data and identifiers from keyboard
	    and to statistically analyze the data and plot the histogram and
					the cumulative frequency curve */
	
#include "sedlab.h"
#define MAIN 
#include "gstat.h"

main(argc,argv)
int argc;
char **argv;
{
	FILE *pg;
	char *arg;
	int i,dend;
	int getnav(),loadat();
	
	double atof(),fplist[MAXPLIST],cfp[MAXPLIST],fines;
	/* phi 11 represents data <= 11 & > 10.0, etc .  */

	static double plist[MAXPLIST] = {11.0,10.0,9.0,8.0,7.0,6.0,5.0,4.0,3.0,
			2.0,1.0,0.0,-1.0,-2.0,-3.0,-4.0,-5.0};
	
	pg = NULL;

	while (--argc > 0) {
		if (**++argv == '-')  for (arg = *argv;;) {
			switch (*++arg) {
			default :  
			   fprintf (stderr,
				"GSTATM:  gstat pgout <input >output\n\n");
			   error ("Invalid option \n");
			}
			break;
		}
		else { 
			fprintf (stderr,"Pre-grasp output file is:'%s'\n",
				*argv);
			if ( (pg = fopen(*argv, "a")) == NULL)
				{
				fprintf (stderr,"gstat: can't open '%s'\n",
						*argv);
				exit(1);
				}
			
			}
		}

	
	
	if (getlin() == EOF)
		error ("Empty input file.\n");


	do {
		for (i=0;i < MAXPLIST; i++)
		    {
		    fplist[i] = 0.0;
		    cfp[i] = 0.0;
		    }
		if (loadids() == EOF)  continue;	
		strncpy(alab,labno,MAXLABLET);
		if (getlin() == EOF)  error("EOF reading sample weight.\n");
		sample = atof(line);
		if (getlin() == EOF) error("EOF reading coarse weight.\n");
		coarse = atof(line);
		if (getlin() == EOF)  error("EOF reading sand weight.\n");
		sand = atof(line);
		if (getlin() == EOF)  error("EOF reading navigation.\n");
		if (getnav() == EOF)  error("EOF reading navigation.\n");
		
		gravel = coarse - sand;
		pgravel = ((gravel > 0.0)?gravel/sample:0.00001);
	
		psand = ((sand > 0.0) ? sand/sample:0.00001);
		
		pfine = ( (fines = (sample-coarse)) > 0.0?fines:0.00001)/sample;
		
		if ( (dend = loadat(fplist)) == EOF)  continue;
		fprintf(stderr,"Data retrieved for '%s'\n",labno);
		
		pclay = 0.0;
		psilt = 0.0;
		for (i=0;i<=2;i++) pclay += fplist[i];
		for (i=3; i <= 6; i++)  psilt += fplist[i];
	
		psand *= 100.0;
		pgravel *= 100.0;
		pfine *= 100.0;


		stats(fplist,cfp,dend);
		gprint (fplist,cfp,dend);
		igst(plist,cfp,MAXPLIST);

		/* hplot (fplist); */
		/*     	hplot (cfp); */
		if (pg != NULL) pgprint (pg,cfp);
	}  while (eofstat != EOF);

    fprintf(stderr,"Data processing completed.\n");

    }

