/* iqhscu - jjfredericks C-version of IMSL quasi-cubic Hermite piece-wise 
		polynomial interpolation routine    4/85 */
#include "sedlab.h"
int
iqhscu(x,y,nx,c,ic)
double x[],y[],c[][MAXPLIST];
int ic,nx;
	{
	int i,n0;
	double t1,t2,b,rm1,rm2,rm3,rm4;
	
	if (ic < nx)  return (129);
	if (nx <= 3)  return (130);
	for (i = 1; i < nx ; i++)
		if (x[i] <= x[i-1]) return(131);
	
	rm3 = (y[1]-y[0])/(x[1]-x[0]);
	t1 = rm3 - (y[1]-y[2])/(x[1]-x[2]);
	rm2 = rm3 + t1;
	rm1 = rm2 + t1;
	
	/* now get slopes */
	n0 = nx - 3;
	for (i=0; i < nx ; i++)
		{
		if (i > n0)  rm4 = rm3 - rm2 + rm3;
		else  rm4 = (y[i+2]-y[i+1])/(x[i+2]-x[i+1]);
		t1 = abs(rm4 - rm3);
		t2 = abs(rm2 - rm1);
		b = t1 + t2;
		if (b == 0) c[0][i] = 0.5*(rm2+rm3);
		else  c[0][i] = (t1*rm2+t2*rm3)/b;
		rm1 = rm2;
		rm2 = rm3;
		rm3 = rm4;
		}

	n0 = nx - 2;
	for (i=0 ; i <= n0 ; i++)
		{
		t1 = 1.0/(x[i+1]-x[i]);
		t2 = (y[i+1]-y[i])*t1;
		b = (c[0][i]+c[0][i+1]-t2-t2)*t1;	
		c[2][i] = b*t1;
		c[1][i] = -b+(t2-c[0][i])*t1;
		}
	return  (0);
	}

