/* name - to classify sample using Shepard's Classification methods */

#include "sedlab.h"
#include "gstat.h"

char *
name()
	{
	static char *type[] = {
		"GRAVEL > 10%",
		"SAND        ",
		"SILT        ",
		"CLAY        ",
		"SANDY CLAY  ",
		"SILTY CLAY  ",
		"CLAYEY SILT ",
		"SANDY SILT  ",
		"SILTY SAND  ",
		"CLAYEY SAND ",
		"SAN SIL CLAY"};
	
	double sandp,sansil,clysnd,silcly;

	if (pgravel > 10.0) return type[0];

	if (psand == 0.0)  psand = 0.001;
	if (psilt == 0.0)  psilt = 0.001;
	if (pclay == 0.0)  pclay = 0.001;

	sandp = psand + pgravel;
	if (sandp >= 75.0)  return type[1];
	if (psilt >= 75.0)  return type[2];
	if (pclay >= 75.0)  return type[3];
	
	sansil = sandp/psilt;
	clysnd = pclay/sandp;
	silcly = psilt/pclay;
	
	if (sandp <= 20.0)
		{
		if (sansil > 1.0)  return type[4];
		if (silcly < 1.0)  return type[5];
		if (clysnd > 1.0)  return type[6];
		return type[7];
		}
	else if (pclay <= 20.0)
		{
		if (sansil < 1.0)  return type[7];
		if (silcly > 1.0)  return type[8];
		return type[9];
		}
	else if (psilt <= 20.0)
		{
		if (clysnd <= 1.0)  return type[9];
		return type[4];
		}
	else 
		{
		return type[10];
		}
	}

