/*jsplit - program to copy complete samples to new file & leave incomplete
            samples in old file */

#include <stdio.h>
#include "sedlab.h"

char alab[MAXLABLET];
int i; 	/* i= current pointer on line */

struct sample {
	char line[MAXLINE],labno[MAXLABLET],type[MAXTYPLET];
}  asam[MAXSAMS] , *psam;
int stat,nline; /* EOF status , line number for each sample set */

main(argc, argv)
int argc;
char *argv[];
{
	FILE *temp,*newfil,*oldfil,*fopen();

	if (argc != 4) /* no args - abort run */
	{
		fprintf (stderr,"JSPLIT: Usage 'jsplit temp oldfil newfil'\n");
		exit(1);
	}
	/* open oldfil for input & newfil for output of complete data sets */
	if ( (temp = fopen(*++argv,"r")) == NULL)
	{
		fprintf (stderr,"JSPLIT: error opening input file '%s'\n",
		    *argv);
		exit(1);
	}
	if ( (oldfil = fopen(*++argv,"w")) == NULL)
	{
		fprintf (stderr,"JSPLIT: error opening file '%s'\n",*argv);
		exit(1);
	}
	if ( (newfil = fopen(*++argv,"a+")) == NULL)
	{
		fprintf (stderr,"JSPLIT: error opening file '%s'\n",*argv);
		exit(1);
	}

	stat = ~(EOF);
	nline = 0;

	while (stat != EOF)
	{
		if (getfrst(temp) == EOF)  break;
		/* while line read is still same lab number */
		while (strncmp(alab,psam->labno,MAXLABLET) == 0)
		{
			nline++;
			psam++;

			if (nline >= MAXSAMS)  break;
			if ((stat=getsam(temp)) == EOF)  break;
		}
		if (nline >= MAXSAMS) {
			printf ("All samples present for '%s'\n",alab);
			rcopy(newfil);
			nline = 0;
		}
		else 
			rcopy(oldfil);
	}

	fclose(newfil);
	fclose(oldfil);
	fclose(temp);
	exit(0);
}



/*   ********** GETSAM ********** to get a line from the sorted temp file */

int
getsam(temp)
FILE *temp;
{
	int len,getlab();
	void gettyp();

	if (fgets(psam->line,MAXLINE,temp) == NULL)
		return (EOF);
	if ( (len = strlen(psam->line)) >= MAXLINE)
		{
		fprintf (stderr,"Input line too long for:'%s'\n",psam->line);
		exit(1);
		}
	asam[nline].line[len-1] = '\0';
	if(getlab())
	  {fprintf(stderr,"EOF in getlab (jsplit)\n");
	  return(EOF);
	  }
	gettyp();
	return (~EOF);
}

/*   ********** GETFRST ********** to get the first line of a sample set */
int
getfrst(temp)
FILE *temp;
{
	struct sample *lsam;

	lsam = &asam[nline];
	psam = &asam[0];

	if (nline == 0 ) {
		if (getsam(temp) == EOF)
			return EOF;
	}
	else {
		strcpy (psam->line,lsam->line);
		strcpy (psam->labno,lsam->labno);
		nline = 0;
	}
	strcpy (alab,psam->labno);
	return ~(EOF);
}


/*   ********** GETLAB ********** to parse the labno from the sample line  */
int
getlab()

{
	int j;
	char c;

	/* find labno flag ">>"  */


	for (i=0; i <= MAXLINE ; i++)
		{
		if (asam[nline].line[i] == EOS) {
			fprintf (stderr,"Error in sorted file temp line='%s'\n",
			    psam->line);
			return (-1);
			}
		if (asam[nline].line[i] == '>' & asam[nline].line[i+1] == '>')
			break;
		}

	/* get labno from line */
	i += 2;

	for (j=0; j <= MAXLABLET ; j++)
		{
		c = asam[nline].line[i];
		if (c == BLANK || c == ',')
			break;
		if (c == EOS)
			{
			fprintf(stderr,"Unexpected EOS as labno.\n");
			exit(2);
			}
		asam[nline].labno[j] = c;
		i++;
		}

	asam[nline].labno[j] = EOS;
	i++;
	return(0);
	}

/*   ********** GETTYP ********** to parse the sample type from the line */
void
gettyp ()
	{
	int j;
	while (asam[nline].line[i] <= BLANK )  i++;

	for (j=0; asam[nline].line[i] != BLANK ; j++)
	{
		if (asam[nline].line[i] == EOS)
			{
			printf (" Unexpected line length at labno '%s'\n",
			    psam->labno);
			break;
			}

		if (j >= MAXTYPLET) {
			printf (" TYPE TOO LONG ");
			break;
			}
		asam[nline].type[j] = asam[nline].line[i++];
		if (asam[nline].line[i] == ',')  break;
		}
	asam[nline].type[j] = EOS;
	i++;
	return;
	}

/*   ********** RCOPY ********** to copy nline - 1 lines to new/old file */

rcopy(afil)
FILE *afil;
{
	int i,nl;
	char *string,*strtok(),*rlab,*rtype,*word1,*word2;

	for ( nl = 0 ; nl < nline ; nl++ )
		{
		psam = &asam[nl];
		if (asam[nl].type[0] == 'N')
		  fprintf(afil,"%s\n",psam->line);
		else
			{
			strtok(psam->line," ");	/* skip labno */
			strtok(cnull," ");	/* skip type  */
			fprintf (afil,">>%s %s\n",psam->labno,psam->type);
			for (i = 1; i <= 6; i++)
				fprintf(afil,"  %s\n",strtok(cnull," "));
			if (asam[nl].type[0] == 'R')
			if (asam[nl].type[0] == 'R')
				{
				for (i=1;i<=3;i++)	/* print out weights */
				  fprintf(afil,"  %s\n",strtok(cnull," "));
				}
			/* for all pairs of data on line - print out a pair */
			while ( (word1 = strtok(cnull," ")) != cnull)
				{
				word2 = strtok(cnull," ");
				fprintf (afil,"  %s %s\n",word1,word2);
				}
			}	
		}
	return;
}
