#include <stdio.h>
#define COMMA ','
#define BLANK ' '

/*  io.lib - library for "C" input output routines */

/*  prompt - to prompt user & return response in line */
prompt (string,line,maxchars)
char *string,*line;
int maxchars;
{
	char c,*frstc,*maxlin;
	
	frstc = line;
	maxlin = frstc + maxchars;

	do
	{
	
	printf ("%s",string);

/*  response - to get a response from stdin with no imbedded blanks or commas
	       returns (EOF) when EOF encountered
	       returns (NULL) when blank, comma or no data encountered  
	       else returns pointer to response */

	   line = frstc;
	   if ( gets(line) == NULL) return (EOF);
	   if (*line == NULL) 
		{
		c = COMMA;
		continue;
		}
	   while (c = *line++)
		{
		if (line >= maxlin) 
		   {
		   printf ("\007  Field length must be < %d , TRY AGAIN!! **\n",
			maxchars);
		   c = COMMA;
		   break;
		   }

		if (c == COMMA || c == BLANK)
		   {
	           	printf ("\007 No imbedded spaces or commas allowed.\n");
			break;
		        }
		}
	   
	   }  while(c == COMMA || c == BLANK);
	return c ;
}

fetch(string,carray,maxstr)
char *string,*carray;
int maxstr;
	{
	/* fetch prompts stdout with string;
	   if user responds just return from stdin:
		the carray is left untouched (allows for default values 
	   if user responds ' ' & return from stdin:
		the carray is blanked out (blank and '\0')	*/
	char *frst,line[80];
	int i;
	
	frst = carray;
	loop:
	carray = frst;
	printf ("%s(%s):",string,carray);
	if (gets(line) == NULL)  return (EOF);
	if (line[0] == '\0')  return ~EOF;
	i = 0;
	while (*carray = line[i])
		{
		if (i >= maxstr-1)
			{
			fprintf(stderr,
			"\007  String too long must be <= %d chars\n",maxstr-1);
			goto loop;
			}
		if (*carray >= 'a'  && *carray <= 'z')
			*carray = *carray - 32; /*convert to uppercase */
		carray++;
		if (line[i++] == ',' )
			{
			fprintf(stderr,"\007 No imbedded commas.\n");
			goto loop;
			}
		}
	return ~EOF;
	}

/* error to printout message and die */
error(str)
char *str;
	{
	fprintf(stderr,"%s\n");
	exit(1);
	}
		
