/*Procedure to read control parameters and data from a line
given with a list of pointers to words, and the number of words
in each record.
Control records begin with '#' as the first character.
Operational options are preceded by a dash (-), and may be entered in clusters
such as '-xy xval yval', or singly such as '-x xval -y yval', etc., 
where 'xval' and 'yval' are the constants for options x and y, 
respectively.
Control data constants must be input as number pairs, each of which
is considered a single entry in the form
'int,val' where 'int' is an integer specifying the field to which the
following real number 'val' applies.
Any character may be used to separate the components of constants pairs.
All control record entries must be separated by at least one space.
*/
#include <stdio.h>

/*this code is for the 3 following variables...change as nedded*/

#define DELIM '\t' 	/*an alphnumeric delimiter..1 character*/
#define XFIELD 1  	/*an integer variable*/
#define YFIELD 2  	/*an integer variable*/

extern int xfield, yfield, varno[];

extern char delim;

extern double xbar[];

static int nvar;

extern FILE *vb;

runline(argc, argv)

int argc;
char **argv;

{
int j;


char 	*p, **data;

	data = argv;
	j = 0;					      
	nvar = 0;
					   	   /*process argc-1 fields*/

	while( --argc > 0 ){
		if( **argv == '-' ) 
			for( p = *argv;; ){     /*if an option*/

				switch ( *++p ){

					case '\0': if( argc > 0)
					 	   *++argv; 
						   break;

					case 'x': if(argc-- > 0)
					  	  xfield= atoi(*++argv);
					 	  continue;

					case 'y': if(argc-- > 0)
						  yfield= atoi(*++argv);
						  continue;

					case 'd': if(argc-- > 0)
					          delim = **++argv; 
						  continue;

					default: fprintf(vb,
						 "faulty control-line\n"); 
					         break;

			        }
				break;
		}
		else			        /*for a 'varno,xbar' pair*/
			if( argc-- > 0  ){
				if( strchr(*argv,',') ){
					varno[j++] = strtol( *argv, &*argv, 0);
					xbar[j] = atof( **++argv);
					nvar++;
printf("<varno[%d]=%d>\n",varno[j]);
printf("<xbar[%d]=%f>\n",xbar[j]);
				}
				else return;
			}
			else			    /*must be a data record*/
				if( argc-- > 0 ) 
					data[j++] = *argv;
	}
	return;
}
