/*
**	two forms: traditional white space words for control and
**		"tab"ed words for data.
*/

# include <ctype.h>
# include <string.h>

	static char *
escpar(s) char **s; {
	register n, c, i;
	char *nc, *curr;

	curr = nc = *s;

	if (isdigit(c = *++curr)) { /* octal constant */
		n = c - '0';
		for (i = 0; i < 2 && isdigit(c = *++curr) ; i++)
			n = (n << 3) + (c - '0');
		if (i < 2) --curr;
	} else if (c == 'x' || c == 'X') { /* hex constant */
		for (n = i = 0; i < 3 && isxdigit(c = *++curr) ; ++i) {
			n = (n << 4) + c;
			if (isdigit(c)) n -= '0';
			else n += c > 'F' ? 10-'a' : 10-'A';
		}
		if (i < 3) --curr;
	} else  /* special escape characters */
		switch (c) {
		case 't': n = '\t'; break;
		case 'b': n = '\b'; break;
		case 'r': n = '\r'; break;
		case 'n': n = '\n'; break;
		case 'f': n = '\f'; break;
		default: n = c; break; /* else anything */
		}
	*nc++ = n;
	*s = c ? curr : curr-1;
	return(nc); /* return current source ptr */
}

/* control words, separated by 'white space' */

words(s, maxc, argv, func)
char *s, **argv;
int maxc;
int (*func)();
{
	int  argc;
	register c;
	char *d;

	for (c = *s, argc = 0; c && argc < maxc ; ) {
		while (isspace(c)) c = *++s;
		if (c) {
			argv[argc++] = d = s;
			do {
				if (c == '\\')
					d = escpar(&s);
				else
					*d++ = c;
				c = *++s;
			} while (c && !isspace(c));
			*d = '\0';
		}
	}
	return ((*func)(argc, argv));
}
